import { File, NodePath, types } from '@babel/core';

type ReplaceSupersOptionsBase = {
    methodPath: NodePath<types.ClassMethod | types.ClassProperty | types.ObjectMethod | types.ClassPrivateMethod | types.ClassPrivateProperty | types.StaticBlock>;
    constantSuper?: boolean;
    file: File;
    refToPreserve?: types.Identifier;
};
type ReplaceSupersOptions = ReplaceSupersOptionsBase & ({
    objectRef?: undefined;
    getObjectRef: () => types.Node;
} | {
    objectRef: types.Node;
    getObjectRef?: undefined;
}) & ({
    superRef?: undefined;
    getSuperRef: () => types.Node;
} | {
    superRef: types.Node;
    getSuperRef?: undefined;
});
declare class ReplaceSupers {
    constructor(opts: ReplaceSupersOptions);
    file: File;
    isDerivedConstructor: boolean;
    constantSuper: boolean;
    isPrivateMethod: boolean;
    isStatic: boolean;
    methodPath: NodePath;
    opts: ReplaceSupersOptions;
    getObjectRef(): types.Node;
    getSuperRef(): types.Node;
    replace(): void;
}

export { ReplaceSupers as default };
